<?php


$VTIME = time() - 36 * 31 * 24 * 60 * 60;
$TABLES = array("contenttag", "ds", "ds_obj", "page", "value");

global $DEBUGMODE;

$DEBUGMODE = false;










foreach ($TABLES as $k => $table) {
 $tr = new TableVersionRepair($table, $VTIME);
 $tr->execute();
 $stats[$table] = array(
 "created" => $tr->created,
 "fixed" => $tr->fixed,
 "time" => $tr->time
 );
 unset($tr);
}

echo "Exec stats:\n";
var_dump($stats);




class TableVersionRepair { 
 
 var $table = false;
 var $vtime = false;
 var $fixed = 0;
 var $created = 0;
 var $BATCHSIZE = 10000;
 var $TIMEZONE_OFFSET = 0;
 var $time = 0;
 
 


 var $keys = false;
 
 




 function TableVersionRepair($table, $vtime) {
 $this->table = $table;
 $this->vtime = $vtime;
 $this->TIMEZONE_OFFSET = (intval(date('O')) / 100 * 3600);
 
 $this->generateKeys();
 }
 
 


 function execute() {
 global $DEBUGMODE;
 $start = time();
 
 echo "\nExecuting repair ".($DEBUGMODE ? "in debug mode " : "")."on table \"$this->table\" using timestamp \"$this->vtime\"\n\n";

 $datacols = implode(",", $this->keys);








 $continue = true;
 while ($continue) {
 $res = query("SELECT id, min(nodeversiontimestamp) oldestversion FROM ".$this->table."_nodeversion group by id having oldestversion > ".$this->vtime." limit ".$this->BATCHSIZE);
 $this->fixed += $res["num"];

 while (list($k, $v) = each($res["arr"])) {
 
 $sql = "INSERT INTO ".$this->table."_nodeversion ($datacols, nodeversiontimestamp, nodeversion_user, nodeversionlatest, nodeversionremoved) SELECT $datacols, $this->vtime, 1, 0, 0 FROM ".$this->table."_nodeversion WHERE id = ".$v["id"]." AND nodeversiontimestamp = ".$v["oldestversion"];
 if (!$DEBUGMODE) {
 query($sql);
 } else {
 echo $sql."\n";
 }
 }

 if ($res["num"] == 0) {
 $continue = false;
 }


 unset($res);






 }


 

 $sql = "INSERT INTO ".$this->table."_nodeversion($datacols, nodeversiontimestamp, nodeversion_user, nodeversionlatest, nodeversionremoved) SELECT $datacols, $this->vtime, 1, 1, 0 FROM ".$this->table." WHERE id in (SELECT ".$this->table.".id FROM ".$this->table." left join ".$this->table."_nodeversion on ".$this->table.".id = ".$this->table."_nodeversion.id WHERE ".$this->table."_nodeversion.id IS NULL)";
 if (!$DEBUGMODE) {
 query($sql);
 } else {
 echo $sql."\n";
 }




















 echo "Repair for table \"$this->table\" finished (timestamp \"$this->vtime\")\n";
 $this->time = time() - $start;
 }

 


 function generateKeys() {
 if ($this->keys) {
 return;
 }

 
 $origcols = mydb_desc_table($this->table, false, true);
 
 $versioncols = mydb_desc_table($this->table."_nodeversion", false, true);

 
 $this->keys = array_keys(array_intersect_assoc($origcols, $versioncols));
 }
}


?>
