
var m_layers = new Array();
var ani_step = 0;
var do_ani = false;

var m_layer;
var m_width;
var m_height;
var m_rows;

var m_textRow;
var m_textCenter;

var c_space = 9;
var c_textcolor = '#66AA66';
var c_textHiColor = '#88FF88';
var c_maxLines = 40;
var c_maxLineRows = 7;
var c_minLineRows = 3;

var c_chars = "abcdefghijklmnopqrstuvwxyz1234567890?&%$??#??ABCDEFGHIJKLMNOPQRSTUVWXYZi()[]{},.;:-*~<>";

var c_lines = new Array("Gentics", "proudly presents", "Gentics .Node(R) Application Server v3.6", 
						"[written by]", "'Guru' Erwin Mascher", "'GoHf' Stefan Hepp", "'Chef' Laurin Herlt", "'Hecka' Haymo Meran",
						"'Eikzilla' Eik Umlauf","'Kyle' Harald Piringer","'MoreFun' Gerhard Wohlgenannt","'God' Clifford Wolf",
						"'Matl' Martin Artner","'MrT' Adam Vissing", "'Coda' Klaus-M. Schremser", "'Inda' Raoul Bhatia", 
						"Robert 'Rob' Reinhardt","Norbert 'NOP' Pomaroli","Bernhard 'Berni' Kogler",
						"Herbert 'Herby' Poul", "Thomas 'TomTurbo' Moser", "Clemens 'Vrrrrm' Prerovsky",
						"[starring]", "Gentics Content.Node(R)", "Gentics Tracking.Node(R)", "Gentics Portal.Node(R)",
						"Gentics Business.Node(R)","Gentics Shop.Node(R)",
						"[featuring]", "LiveEditor", "XNL","RealEditor", "free Workflows", "n-Language Support", "LDAP Bindings", 
						"Task Scheduler", "J2EE Interface", "... Warning, featurelist exceeds memory limit. Halted.",
						"[special thanks to]", "'Chefe' Alex Szlezak", "'Chefe' Georg Geczek", "'Alex' Alfons Lex", 
						"'MF' Christian Berchthold", "'Testa' Nici Piso", "'Powerpuff' Marion Thume", "'Eva' Eveline Orff",
						"Petra 'mei Alex' Schweiger", "Oliver 'Olli/Master/Referee' Herlt", "Manfred Wiesinger","Manuel Aghamanoukjan", "Dominik 'Screwmaster' Dejmek" );
var c_scrollCycle = 2500;
var c_scrollDelay = 8;
var c_scrollWait = 2000;

var p_started = false;

function check_click(event, layer) {
	if (!p_started) {
		if (document.all) {
			if (!window.event.shiftKey) return;
			if (window.event.clientX < 135 || window.event.clientX > 140) return;
			if (window.event.clientY < 12 || window.event.clientY > 16) return;
		} else {
			
			return false;
		}
		start_matrix(layer, 86, 1300);
	}
	else stop_matrix();
	p_started = !p_started;
}


function start_matrix(layer, height, width) {
	m_layer = layer;
	m_height = height;
	m_width = width;
	m_rows = Math.ceil(height/10);
	m_textRow = Math.floor(m_rows/2) - 1;
	m_textCenter = Math.floor(m_width/(2*c_space));
	ani_step = 1;
	if (!do_ani) {
		do_ani = true;
		animate();
	}
}

function stop_matrix() {
	ani_step = 20;
}



var p_anilaststep = 0;

function animate() {
	var firsttime = (ani_step != p_anilaststep);
	p_anilaststep = ani_step;

	switch (ani_step) {
		// init layer
		case 1: gen_layers(firsttime); ani_step = 2; break;
		case 2: fade_layer(firsttime, true); break;
		case 3: reset_text(); ani_step = 10; break; 
		// animate layer
		case 10: update_code(firsttime); break;

		// stop layer
		case 20: fade_layer(firsttime, false); break;
		case 21: do_ani = false;
	}
	if (do_ani) window.setTimeout("animate()", 48);
}

var p_horLine;
var p_pos = 0;

function fade_layer(firsttime, fadein) {
	if (firsttime && fadein) {
		m_layer.style.position = 'absolute';
		m_layer.style.top = "0px";
		m_layer.style.left = "0px";
		m_layer.style.height = "0px";
		m_layer.style.width = m_width+"px";
		m_layer.style.backgroundColor = '#000000';
		m_layer.style.zIndex = 9998;
		m_layer.style.visibility = 'visible';
	}
	
	if (firsttime) {
		p_horLine = document.createElement("div");
		p_horLine.style.position = 'absolute';
		p_horLine.style.top = "-1px";
		p_horLine.style.height = "2px";
		p_horLine.style.left = "0px";
		p_horLine.style.width = m_width+"px";
		p_horLine.style.backgroundColor = c_textcolor;
		m_layer.appendChild(p_horLine);
		p_pos = 0;
	} else {
		if (fadein) {
			m_layer.style.height = p_pos+"px";
			p_horLine.style.top = (p_pos - 1) + "px";
		} else {
			m_layer.style.top = p_pos + "px";
		}
	}

	if (p_pos > m_height) {
		m_layer.removeChild(p_horLine);
		ani_step++;
	} else {
		// move on with frame
		p_pos += Math.ceil(p_pos/4) + 1;
	}
}

function gen_layers(firsttime) {
	var j = 0;
	var pre,txt,div;
	for (var i = 0; i < m_layers.length; i++) {
		m_layer.removeChild(m_layers[i].parentNode.parentNode);
	}
	m_layers = new Array();
	for (var i = 0; i < m_width; i+=c_space) {
		div = document.createElement("div");
		div.style.position = 'absolute';
		div.style.top = '0px';
		div.style.left = i+'px';
		div.style.height = m_height+'px';
		div.style.width = c_space+'px';
		div.style.visibility = 'visible';
		div.style.textAlign = 'center';
		div.style.fontWeight = 'bold';
		div.style.fontSize = '10pt';
		div.style.lineHeight = '9pt';
		div.style.fontFamily = 'sans-serif';
		div.style.color = c_textcolor;
		div.style.zIndex = 9999;
		
		pre = document.createElement("pre");
		txt = document.createTextNode(" \n");
		pre.appendChild(txt);
		div.appendChild(pre);
		m_layer.appendChild(div);
		m_layers[j] = txt;
		j++;
	}
	
	ani_step++;
}


function update_code(firsttime) {
	if (firsttime) {
		setLineCount(c_maxLines);
		start_scroller();
	}
	updateText();
}

var p_lines = new Array();
var p_lineData = new Array();
var p_showLines = 0;

function reset_text() {
	var p_lines = new Array();
	var p_lineData = new Array();
}

function setLineCount(percent) {
	p_showLines = Math.ceil((percent/100)*(m_width/c_space));
}

function updateText() {
	_addLines();
	for (var i = 0; i < p_lines.length; i++) {
		_drawLine(i);
	}
}

function _addLines() {
	var diff = p_showLines - p_lines.length;
	if (diff > 0) {
		var j = Math.floor(diff/5) + 1;
		for (var i = 0; i < j; i++) {
			p_lines[p_lines.length] = new CodeLine(p_lines.length);
		}
	}
}

function CodeLine(index) {
	this.status = 0;
	this.code = "";
	var i = 0;
	while (i < 20) {
		this.start = _rand(m_rows - 1);
		this.layer = _rand(m_layers.length);
		if (getCodeChar(this.layer, this.start) == " ") break;
		i++;
	}
	this.index = index;
	this.hiChar = false;
	this.maxLen = c_minLineRows + _rand(c_maxLineRows - c_minLineRows);
	this.wait = 0;
}

function _drawLine(line) {
	var changed = false;
	var deleted = false;
	var l = p_lines[line];
	switch (l.status) {
		case 0:
			// add code
			var c = _getRandomChar();
			setCodeChar(l.layer, l.start + l.code.length, c, true);
			changed = true;
			l.code += c;
			if (l.code.length >= l.maxLen) {
				l.status = 3;
			}
			break;
		case 1:
			// wait
			l.wait++;
			if (l.wait >= l.maxLen) l.status = 3;
			break;
		case 2:
			// del code
			var override = (l.code.substr(0,1) != getCodeChar(l.layer, l.start));
			var override = false;
			if (!override) {
				setCodeChar(l.layer, l.start, " ", false);
				changed = true;
			}
			if (override || l.code.length <= 1) {
				_deleteLine(line);
				deleted = true;
			} else {
				l.start++;
				l.code = l.code.slice(1);
				l.maxLen--;
				if (l.maxLen <= 1) l.status = 3;
			}
			break;
		case 3:
			// new step
			l.status = _rand(5);
			if (l.status > 2) l.status = 2;
			if (l.status == 1) l.maxLen = _rand(30);
			else {
				l.maxLen = _rand(c_maxLineRows);
				if (l.status == 2) l.maxLen += 2;
			}
			l.wait = 0;
			break;
	}
	if (changed) _updateLayerCode(l.layer);
	if (!deleted) p_lines[line] = l;
	
	return changed;
}

function _deleteLine(line) {
	var c = false;
	for (var i = 0; i < p_lines.length - 1; i++) {
		if (i == line) c = true;
		if (c) {
			p_lines[i] = p_lines[i + 1];
			p_lines[i].index = i;
		}
	}
	p_lines.pop();
}


var p_scrollStatus;
var p_scrollText;
var p_scrollTextId;
var p_scrollPos;
var p_scroll;

function start_scroller() {
	if (p_scroll || !c_lines) return;
	p_scroll = true;
	p_scrollStatus = 0;
	p_scrollText = "";
	p_scrollTextId = 0;
	scroll_animate();
}

function scroll_animate() {
	if (!do_ani || ani_step != 10) {
		p_scroll = false;
		return;
	}
	
	var update = 20;
	
	switch (p_scrollStatus) {
		case 0:
			// wait for next text..
			update = c_scrollCycle;
			p_scrollText = "";
			p_scrollStatus = 1;
			p_scrollPos = 0;
			break;
		case 1:
			// scramble in
			if (p_scrollPos == 0) init_scroller();
			else scramble_scroller(true);
			update_scroller();
			p_scrollPos++;
			if (p_scrollPos >= c_scrollDelay) p_scrollStatus = 2;
			break;
		case 2:
			// show text
			_setScrollText(c_lines[p_scrollTextId]);
			update_scroller();
			update = c_scrollWait;
			p_scrollStatus = 3;
			break;
		case 3:
			// scamble out
			if (p_scrollPos <= 1) init_scroller();
			else scramble_scroller(false);
			update_scroller();
			p_scrollPos--;
			if (p_scrollPos <= 0) {
				p_scrollStatus = 0;
				p_scrollTextId = (p_scrollTextId + 1) % c_lines.length;
			}
			break;
	}
	window.setTimeout("scroll_animate()", update);
}

function init_scroller() {
	var text = "";
	for (var i = 0; i < c_lines[p_scrollTextId].length; i++) {
		text += " ";
	}
	_setScrollText(text);
	var p = _getScrollLayer(0);
	for (var i = 0; i < p_scrollText.length; i++) {
		setCodeChar(p + i, m_textRow, getCodeChar(p, m_textRow), false);
	}
}

function scramble_scroller(fadein) {
	var text = "";
	var c,r;
	for (var i = 0; i < c_lines[p_scrollTextId].length; i++) {
		c = p_scrollText.charAt(i + 2);
		r = _rand(3);
		if ((fadein && (c != " " || r == 0)) || (!fadein && r > 1)) {
			text += _getRandomChar();
		} else {
			text += " ";
		}
	}
	_setScrollText(text);
}

function _setScrollText(text) {
	p_scrollText = "  " + text + "  ";
}

function update_scroller() {
	var p = _getScrollLayer(0);
	for (var i = 0; i < p_scrollText.length; i++) {
		_updateLayerCode(p + i);
	}
}

function _getScrollLayer(char) {
	return m_textCenter - Math.ceil(p_scrollText.length/2) + char;
}

function _getRandomChar() {
	return c_chars.charAt(_rand(c_chars.length));
}

function isFixedChar(col, row, isSet) {
	if (row != m_textRow || p_scrollText == "") return "";
	var i = _getScrollLayer(0);
	if (col < i || col >= i + p_scrollText.length) return "";
	return p_scrollText.charAt(col - i);
}

function getCodeChar(col, row) {
	if (!p_lineData[col]) return " ";
	var c = p_lineData[col].charAt(row*2);
	if (!c) return " ";
	return c;
}

function setCodeChar(col, row, char, hi) {
	if (!p_lineData[col]) p_lineData[col] = "";
	for (var i = p_lineData[col].length; i < (row + 1) * 2; i+=2) {
		p_lineData[col] += "  ";
	}
	var code = p_lineData[col].slice(0, row * 2);
	code += char;
	code += hi?"1":" ";
	code += p_lineData[col].slice((row * 2) + 2);
	p_lineData[col] = code;
}

function isHighlight(col, row) {
	var c = p_lineData[col].charAt(row*2 + 1);
	if (c == " ") return false;
	else return c;
}

function _updateLayerCode(layer) {
	var code = "";
	var c,d;
	var hi;
	var max = Math.min(Math.floor(p_lineData.length/2), m_rows);
	for (var i = 0; i < max; i++) {
		c = p_lineData[layer].charAt(i*2);
		d = isFixedChar(layer, i, (c == " "));
		code += _translateChar((d == "")?c:d,isHighlight(layer,i));
	}
	m_layers[layer].nodeValue = code;
}

function _translateChar(char, hi) {
	return char+"\r\n";
}

function _rand(max) {
	return Math.min(Math.floor(Math.random()*max), max - 1);
}

