<?




class ContentRepository extends CNObject {
 var $cr_id;

 function __construct($id) {
 $this->setID($id);
 }
 
 function ContentRepository($id) {
 $this->setID($id);
 }

 function getID() {
 return $this->cr_id;
 }

 function setID( $id ) {
 $this->cr_id = $id;
 }

 


 function isMultichannelingCR() {
 $sql = "SELECT multichannelling from contentrepository WHERE id = " . sqlf_tl_num($this->getID());
 $res = query($sql);
 $isMCCR = $res['arr']['0']['multichannelling'] == 1;
 return $isMCCR;
 }
 
 function _getNodeTable() {
 return "contentrepository";
 }

 function _checkPermission($parentObjectType, $parentObjectId, $o_type, &$row) {
 global $USER_ID;
 return perm($USER_ID, T_CONTENTREPOSITORY, $this->getID(), 0);
 }

 function getIcon() {
 global $ICO_CONTENTREPOSITORY;
 return $ICO_CONTENTREPOSITORY;
 }

 function getTType () {
 return T_CONTENTREPOSITORY;
 }

 function getParentTType() {
 return array(T_CONTENTREPOSITORIES);
 }

 function getValueFields() {
 return array( 'name' => 'text',
 'dbtype' => 'text',
 'url' => 'text',
 'username' => 'text',
 'password' => 'text',
 'checkdate' => 'int',
 'checkresult' => 'textarea',
 'instant_publishing' => 'int',
 'multichannelling' => 'int',
 'diffdelete' => 'int',
 'language_information' => 'int',
 'permission_information' => 'int',
 'datastatus' => 'int',
 'datacheckresult' => 'textarea',
 'basepath' => 'text',
 );
 }

 function canDelete() {
 global $USER_ID;
 $this->resetErrors();

 
 if (!perm($USER_ID, T_CONTENTREPOSITORY, $this->getID(), 3)) {
 $this->_setError(new NodeException(i18n("No permission to delete ContentRepository '{0}'.", 0, $this->getFieldValue("name"))));
 return false;
 }

 
 $nodes = get_linked_nodes($this->getID());
 if (is_array($nodes) && count($nodes) > 0) {
 $this->_setError(new NodeException(i18n("The ContentRepository '{0}' cannot be deleted, because it is assigned to {1} node(s)", 0, $this->getFieldValue("name"), count($nodes))));
 return false;
 }
 return true;
 }
 
 





 function getSelectOptions($addsql=null, $permflags = 0) {
 global $USER_ID;
 $res = query("SELECT id, name FROM contentrepository $addsql");
 if ($res["num"] == 0) {
 return array();
 }
 if (!is_array($permflags)) {
 $permflags = array( $permflags );
 }
 while (list($k, $v) = each ($res["arr"])) {
 $hasperm = true;
 foreach( $permflags as $perm ) {
 if (!perm($USER_ID, T_CONTENTREPOSITORY, $v["id"], 0)) {
 $hasperm = false;
 break;
 }
 }
 if ($hasperm) {
 $ret[$v["id"]] = $v["name"];
 }
 }
 return $ret;
 }

 function _addPermsOnNewObject($id, $group_id) {
 
 if (perm_group($group_id, T_CONTENTREPOSITORIES, 0, 8)) {
 
 if (perm_group($group_id, T_CONTENTREPOSITORIES, 0, 1)) {
 $perm = "11110000000000000000000000000000";
 } else {
 $perm = "10110000000000000000000000000000";
 }
 perm_set_perms($group_id, T_CONTENTREPOSITORY, $id, $perm);
 }
 }

 function addGroupPermissionsOnNewObject($id, $group_id) {
 $groups = group_getmothergroups($group_id);
 foreach (array_keys($groups) as $group_id) {
 ContentRepository::_addPermsOnNewObject($id, $group_id);
 }
 }

 function addUserPermissionsOnNewObject($id, $user_id = 0) {
 global $USER_ID;

 if (!$user_id) {
 $user_id = $USER_ID;
 }
 
 $groups = user_getmothergroups($user_id);
 if ($groups) {
 while (list($group_id,$val) = each($groups)) {
 ContentRepository::_addPermsOnNewObject($id, $group_id);
 }
 }
 }

 function onInsertObject() {
 global $USER_ID;
 $this->addStaticTagmapEntries();

 ContentRepository::addUserPermissionsOnNewObject($this->getID());
 logcmd(W_CREATE, T_CONTENTREPOSITORY, $this->getID(), 0, "create contentrepository");
 }

 








 function addStaticTagmapEntries() {
 global $NODEPATH, $MODULE;
 $sql = file("$NODEPATH/modules/$MODULE/sql/static_tagmap_entries.sql");
 if (count($sql) == 0) {
 halt(7, "static tagmap entry file ($NODEPATH/modules/$MODULE/sql/static_tagmap_entries.sql) is empty. unable to create static tagmap entries.");
 }
 while (list($k,$line) = each($sql)) {
 $line = trim($line);
 
 if (strlen($line) === 0 || substr($line,0,2) === "--") {
 continue;
 };
 $line = str_replace('#CRID#', ((int)$this->getID()), $line);
 query($line);
 }
 }
 
 function onBeforeDeleteObject() {
 
 query("DELETE FROM tagmap WHERE contentrepository_id = ".sqlf_tl_num($this->getID()));
 }

 function onDeleteObject() {
 logcmd(W_DEL, T_CONTENTREPOSITORY, $this->getID(), 0, "delete contentrepository");
 }

 function onUpdateObject() {
 logcmd(W_EDIT, T_CONTENTREPOSITORY, $this->getID(), 0, "update contentrepository");
 
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache(T_CONTENTREPOSITORY, $this->getID());
 }

 




 function &copyObject() {
 if ($this->isNew()) {
 return null;
 }

 
 $sql = "insert into contentrepository (name, dbtype) select name, dbtype from contentrepository where id = ".sqlf_tl_num($this->getID());
 $rs = query($sql);
 $new_id = $rs["iid"];
 $contentrepository = &NodeFactory::getStaticInstanceOf(T_CONTENTREPOSITORY, $new_id);

 
 for ($i = 1; $i < 100; $i++) {
 $proposed_name = i18n("Copy {0} of {1}", 0, $i, $contentrepository->getFieldValue("name"));
 $sql = "select id from contentrepository where name = '".sqlslashes($proposed_name)."'";
 $rs = query($sql);
 if ($rs["num"] == 0) {
 
 query("update contentrepository set name = '".sqlslashes($proposed_name)."' where id = ".sqlf_tl_num($new_id));
 break;
 }
 }

 
 ContentRepository::addUserPermissionsOnNewObject($new_id);

 
 $sql = "INSERT INTO tagmap (contentrepository_id, tagname, mapname, searchname, object, objtype, attributetype, multivalue, static, optimized, filesystem, foreignlinkattribute, foreignlinkattributerule, category) SELECT ".sqlf_tl_num($new_id).", tagname, mapname, searchname, object, objtype, attributetype, multivalue, static, optimized, filesystem, foreignlinkattribute, foreignlinkattributerule, category FROM tagmap WHERE contentrepository_id = ".sqlf_tl_num($this->getID());
 query($sql);

 $contentrepository = &NodeFactory::getStaticInstanceOf(T_CONTENTREPOSITORY, $new_id);
 return $contentrepository;
 }
}

?>
