<?php












class soap_transport_http extends nusoap_base {

 var $url = '';
 var $uri = '';
 var $digest_uri = '';
 var $scheme = '';
 var $host = '';
 var $port = '';
 var $path = '';
 var $request_method = 'POST';
 var $protocol_version = '1.0';
 var $encoding = '';
 var $outgoing_headers = array();
 var $incoming_headers = array();
 var $incoming_cookies = array();
 var $outgoing_payload = '';
 var $incoming_payload = '';
 var $useSOAPAction = true;
 var $persistentConnection = false;
 var $ch = false; 
 var $username = '';
 var $password = '';
 var $authtype = '';
 var $digestRequest = array();
 var $certRequest = array(); 
 
 
 
 
 
 

 


 function soap_transport_http($url){
 parent::nusoap_base();
 $this->setURL($url);
 ereg('\$Revisio' . 'n: ([^ ]+)', $this->revision, $rev);
 $this->outgoing_headers['User-Agent'] = $this->title.'/'.$this->version.' ('.$rev[1].')';
 $this->debug('set User-Agent: ' . $this->outgoing_headers['User-Agent']);
 }

 function setURL($url) {
 $this->url = $url;

 $u = parse_url($url);
 foreach($u as $k => $v){
 $this->debug("$k = $v");
 $this->$k = $v;
 }
 
 
 if(isset($u['query']) && $u['query'] != ''){
 $this->path .= '?' . $u['query'];
 }
 
 
 if(!isset($u['port'])){
 if($u['scheme'] == 'https'){
 $this->port = 443;
 } else {
 $this->port = 80;
 }
 }
 
 $this->uri = $this->path;
 $this->digest_uri = $this->uri;
 
 
 if (!isset($u['port'])) {
 $this->outgoing_headers['Host'] = $this->host;
 } else {
 $this->outgoing_headers['Host'] = $this->host.':'.$this->port;
 }
 $this->debug('set Host: ' . $this->outgoing_headers['Host']);

 if (isset($u['user']) && $u['user'] != '') {
 $this->setCredentials(urldecode($u['user']), isset($u['pass']) ? urldecode($u['pass']) : '');
 }
 }
 
 function connect($connection_timeout=0,$response_timeout=30){
 
 
 
 








 $this->debug("connect connection_timeout $connection_timeout, response_timeout $response_timeout, scheme $this->scheme, host $this->host, port $this->port");
 if ($this->scheme == 'http' || $this->scheme == 'ssl') {
 
 if($this->persistentConnection && isset($this->fp) && is_resource($this->fp)){
 if (!feof($this->fp)) {
 $this->debug('Re-use persistent connection');
 return true;
 }
 fclose($this->fp);
 $this->debug('Closed persistent connection at EOF');
 }

 
 if ($this->scheme == 'ssl') {
 $host = 'ssl://' . $this->host;
 } else {
 $host = $this->host;
 }
 $this->debug('calling fsockopen with host ' . $host . ' connection_timeout ' . $connection_timeout);

 
 if($connection_timeout > 0){
 $this->fp = @fsockopen( $host, $this->port, $this->errno, $this->error_str, $connection_timeout);
 } else {
 $this->fp = @fsockopen( $host, $this->port, $this->errno, $this->error_str);
 }
 
 
 if(!$this->fp) {
 $msg = 'Couldn\'t open socket connection to server ' . $this->url;
 if ($this->errno) {
 $msg .= ', Error ('.$this->errno.'): '.$this->error_str;
 } else {
 $msg .= ' prior to connect().  This is often a problem looking up the host name.';
 }
 $this->debug($msg);
 $this->setError($msg);
 return false;
 }
 
 
 $this->debug('set response timeout to ' . $response_timeout);
 socket_set_timeout( $this->fp, $response_timeout);

 $this->debug('socket connected');
 return true;
 } else if ($this->scheme == 'https') {
 if (!extension_loaded('curl')) {
 $this->setError('CURL Extension, or OpenSSL extension w/ PHP version >= 4.3 is required for HTTPS');
 return false;
 }
 $this->debug('connect using https');
 
 $this->ch = curl_init();
 
 $hostURL = ($this->port != '') ? "https://$this->host:$this->port" : "https://$this->host";
 
 $hostURL .= $this->path;
 curl_setopt($this->ch, CURLOPT_URL, $hostURL);
 
 curl_setopt($this->ch, CURLOPT_FOLLOWLOCATION, 1);
 
 curl_setopt($this->ch, CURLOPT_HEADER, 1);
 
 curl_setopt($this->ch, CURLOPT_RETURNTRANSFER, 1);
 
 



 
 if ($this->persistentConnection) {
 
 
 
 $this->persistentConnection = false;
 $this->outgoing_headers['Connection'] = 'close';
 $this->debug('set Connection: ' . $this->outgoing_headers['Connection']);
 }
 
 if ($connection_timeout != 0) {
 curl_setopt($this->ch, CURLOPT_TIMEOUT, $connection_timeout);
 }
 
 
 
 
 
 
 

 
 
 

 curl_setopt($this->ch, CURLOPT_SSL_VERIFYPEER, 0);
 curl_setopt($this->ch, CURLOPT_SSL_VERIFYHOST, 0);

 
 if ($this->authtype == 'certificate') {
 if (isset($this->certRequest['cainfofile'])) {
 curl_setopt($this->ch, CURLOPT_CAINFO, $this->certRequest['cainfofile']);
 }
 if (isset($this->certRequest['verifypeer'])) {
 curl_setopt($this->ch, CURLOPT_SSL_VERIFYPEER, $this->certRequest['verifypeer']);
 } else {
 curl_setopt($this->ch, CURLOPT_SSL_VERIFYPEER, 1);
 }
 if (isset($this->certRequest['verifyhost'])) {
 curl_setopt($this->ch, CURLOPT_SSL_VERIFYHOST, $this->certRequest['verifyhost']);
 } else {
 curl_setopt($this->ch, CURLOPT_SSL_VERIFYHOST, 1);
 }
 if (isset($this->certRequest['sslcertfile'])) {
 curl_setopt($this->ch, CURLOPT_SSLCERT, $this->certRequest['sslcertfile']);
 }
 if (isset($this->certRequest['sslkeyfile'])) {
 curl_setopt($this->ch, CURLOPT_SSLKEY, $this->certRequest['sslkeyfile']);
 }
 if (isset($this->certRequest['passphrase'])) {
 curl_setopt($this->ch, CURLOPT_SSLKEYPASSWD , $this->certRequest['passphrase']);
 }
 }
 $this->debug('cURL connection set up');
 return true;
 } else {
 $this->setError('Unknown scheme ' . $this->scheme);
 $this->debug('Unknown scheme ' . $this->scheme);
 return false;
 }
 }
 
 









 function send($data, $timeout=0, $response_timeout=30, $cookies=NULL) {
 
 $this->debug('entered send() with data of length: '.strlen($data));

 $this->tryagain = true;
 $tries = 0;
 while ($this->tryagain) {
 $this->tryagain = false;
 if ($tries++ < 2) {
 
 if (!$this->connect($timeout, $response_timeout)){
 return false;
 }
 
 
 if (!$this->sendRequest($data, $cookies)){
 return false;
 }
 
 
 $respdata = $this->getResponse();
 } else {
 $this->setError('Too many tries to get an OK response');
 }
 } 
 $this->debug('end of send()');
 return $respdata;
 }


 









 function sendHTTPS($data, $timeout=0, $response_timeout=30, $cookies) {
 return $this->send($data, $timeout, $response_timeout, $cookies);
 }
 
 









 function setCredentials($username, $password, $authtype = 'basic', $digestRequest = array(), $certRequest = array()) {
 $this->debug("Set credentials for authtype $authtype");
 
 if ($authtype == 'basic') {
 $this->outgoing_headers['Authorization'] = 'Basic '.base64_encode(str_replace(':','',$username).':'.$password);
 } elseif ($authtype == 'digest') {
 if (isset($digestRequest['nonce'])) {
 $digestRequest['nc'] = isset($digestRequest['nc']) ? $digestRequest['nc']++ : 1;
 
 
 
 
 $A1 = $username. ':' . (isset($digestRequest['realm']) ? $digestRequest['realm'] : '') . ':' . $password;
 
 
 $HA1 = md5($A1);
 
 
 $A2 = 'POST:' . $this->digest_uri;
 
 
 $HA2 = md5($A2);
 
 
 
 
 
 
 
 
 
 
 
 
 $unhashedDigest = '';
 $nonce = isset($digestRequest['nonce']) ? $digestRequest['nonce'] : '';
 $cnonce = $nonce;
 if ($digestRequest['qop'] != '') {
 $unhashedDigest = $HA1 . ':' . $nonce . ':' . sprintf("%08d", $digestRequest['nc']) . ':' . $cnonce . ':' . $digestRequest['qop'] . ':' . $HA2;
 } else {
 $unhashedDigest = $HA1 . ':' . $nonce . ':' . $HA2;
 }
 
 $hashedDigest = md5($unhashedDigest);
 
 $this->outgoing_headers['Authorization'] = 'Digest username="' . $username . '", realm="' . $digestRequest['realm'] . '", nonce="' . $nonce . '", uri="' . $this->digest_uri . '", cnonce="' . $cnonce . '", nc=' . sprintf("%08x", $digestRequest['nc']) . ', qop="' . $digestRequest['qop'] . '", response="' . $hashedDigest . '"';
 }
 } elseif ($authtype == 'certificate') {
 $this->certRequest = $certRequest;
 }
 $this->username = $username;
 $this->password = $password;
 $this->authtype = $authtype;
 $this->digestRequest = $digestRequest;
 
 if (isset($this->outgoing_headers['Authorization'])) {
 $this->debug('set Authorization: ' . substr($this->outgoing_headers['Authorization'], 0, 12) . '...');
 } else {
 $this->debug('Authorization header not set');
 }
 }
 
 





 function setSOAPAction($soapaction) {
 $this->outgoing_headers['SOAPAction'] = '"' . $soapaction . '"';
 $this->debug('set SOAPAction: ' . $this->outgoing_headers['SOAPAction']);
 }
 
 





 function setEncoding($enc='gzip, deflate') {
 if (function_exists('gzdeflate')) {
 $this->protocol_version = '1.1';
 $this->outgoing_headers['Accept-Encoding'] = $enc;
 $this->debug('set Accept-Encoding: ' . $this->outgoing_headers['Accept-Encoding']);
 if (!isset($this->outgoing_headers['Connection'])) {
 $this->outgoing_headers['Connection'] = 'close';
 $this->persistentConnection = false;
 $this->debug('set Connection: ' . $this->outgoing_headers['Connection']);
 }
 set_magic_quotes_runtime(0);
 
 $this->encoding = $enc;
 }
 }
 
 








 function setProxy($proxyhost, $proxyport, $proxyusername = '', $proxypassword = '') {
 $this->uri = $this->url;
 $this->host = $proxyhost;
 $this->port = $proxyport;
 if ($proxyusername != '' && $proxypassword != '') {
 $this->outgoing_headers['Proxy-Authorization'] = ' Basic '.base64_encode($proxyusername.':'.$proxypassword);
 $this->debug('set Proxy-Authorization: ' . $this->outgoing_headers['Proxy-Authorization']);
 }
 }
 
 









 function decodeChunked($buffer, $lb){
 
 $length = 0;
 $new = '';
 
 
 
 $chunkend = strpos($buffer, $lb);
 if ($chunkend == FALSE) {
 $this->debug('no linebreak found in decodeChunked');
 return $new;
 }
 $temp = substr($buffer,0,$chunkend);
 $chunk_size = hexdec( trim($temp) );
 $chunkstart = $chunkend + strlen($lb);
 
 while ($chunk_size > 0) {
 $this->debug("chunkstart: $chunkstart chunk_size: $chunk_size");
 $chunkend = strpos( $buffer, $lb, $chunkstart + $chunk_size);
 
 
 if ($chunkend == FALSE) {
 $chunk = substr($buffer,$chunkstart);
 
 $new .= $chunk;
 $length += strlen($chunk);
 break;
 }
 
 
 $chunk = substr($buffer,$chunkstart,$chunkend-$chunkstart);
 
 $new .= $chunk;
 
 $length += strlen($chunk);
 
 $chunkstart = $chunkend + strlen($lb);
 
 $chunkend = strpos($buffer, $lb, $chunkstart) + strlen($lb);
 if ($chunkend == FALSE) {
 break; 
 }
 $temp = substr($buffer,$chunkstart,$chunkend-$chunkstart);
 $chunk_size = hexdec( trim($temp) );
 $chunkstart = $chunkend;
 }
 return $new;
 }
 
 


 function buildPayload($data, $cookie_str = '') {
 
 $this->outgoing_headers['Content-Length'] = strlen($data);
 $this->debug('set Content-Length: ' . $this->outgoing_headers['Content-Length']);

 
 $req = "$this->request_method $this->uri HTTP/$this->protocol_version";
 $this->debug("HTTP request: $req");
 $this->outgoing_payload = "$req\r\n";

 
 foreach($this->outgoing_headers as $k => $v){
 $hdr = $k.': '.$v;
 $this->debug("HTTP header: $hdr");
 $this->outgoing_payload .= "$hdr\r\n";
 }

 
 if ($cookie_str != '') {
 $hdr = 'Cookie: '.$cookie_str;
 $this->debug("HTTP header: $hdr");
 $this->outgoing_payload .= "$hdr\r\n";
 }

 
 $this->outgoing_payload .= "\r\n";
 
 
 $this->outgoing_payload .= $data;
 }

 function sendRequest($data, $cookies = NULL) {
 
 $cookie_str = $this->getCookiesForRequest($cookies, (($this->scheme == 'ssl') || ($this->scheme == 'https')));

 
 $this->buildPayload($data, $cookie_str);

 if ($this->scheme == 'http' || $this->scheme == 'ssl') {
 
 if(!fputs($this->fp, $this->outgoing_payload, strlen($this->outgoing_payload))) {
 $this->setError('couldn\'t write message data to socket');
 $this->debug('couldn\'t write message data to socket');
 return false;
 }
 $this->debug('wrote data to socket, length = ' . strlen($this->outgoing_payload));
 return true;
 } else if ($this->scheme == 'https') {
 
 
 
 
 
 foreach($this->outgoing_headers as $k => $v){
 $curl_headers[] = "$k: $v";
 }
 if ($cookie_str != '') {
 $curl_headers[] = 'Cookie: ' . $cookie_str;
 }
 curl_setopt($this->ch, CURLOPT_HTTPHEADER, $curl_headers);
 if ($this->request_method == "POST") {
 curl_setopt($this->ch, CURLOPT_POST, 1);
 curl_setopt($this->ch, CURLOPT_POSTFIELDS, $data);
 } else {
 }
 $this->debug('set cURL payload');
 return true;
 }
 }

 function getResponse(){
 $this->incoming_payload = '';
 
 if ($this->scheme == 'http' || $this->scheme == 'ssl') {
 
 $data = '';
 while (!isset($lb)){

 
 if(feof($this->fp)) {
 $this->incoming_payload = $data;
 $this->debug('found no headers before EOF after length ' . strlen($data));
 $this->debug("received before EOF:\n" . $data);
 $this->setError('server failed to send headers');
 return false;
 }

 $tmp = fgets($this->fp, 256);
 $tmplen = strlen($tmp);
 $this->debug("read line of $tmplen bytes: " . trim($tmp));

 if ($tmplen == 0) {
 $this->incoming_payload = $data;
 $this->debug('socket read of headers timed out after length ' . strlen($data));
 $this->debug("read before timeout: " . $data);
 $this->setError('socket read of headers timed out');
 return false;
 }

 $data .= $tmp;
 $pos = strpos($data,"\r\n\r\n");
 if($pos > 1){
 $lb = "\r\n";
 } else {
 $pos = strpos($data,"\n\n");
 if($pos > 1){
 $lb = "\n";
 }
 }
 
 if(isset($lb) && ereg('^HTTP/1.1 100',$data)){
 unset($lb);
 $data = '';
 }
 }
 
 $this->incoming_payload .= $data;
 $this->debug('found end of headers after length ' . strlen($data));
 
 $header_data = trim(substr($data,0,$pos));
 $header_array = explode($lb,$header_data);
 $this->incoming_headers = array();
 $this->incoming_cookies = array();
 foreach($header_array as $header_line){
 $arr = explode(':',$header_line, 2);
 if(count($arr) > 1){
 $header_name = strtolower(trim($arr[0]));
 $this->incoming_headers[$header_name] = trim($arr[1]);
 if ($header_name == 'set-cookie') {
 
 $cookie = $this->parseCookie(trim($arr[1]));
 if ($cookie) {
 $this->incoming_cookies[] = $cookie;
 $this->debug('found cookie: ' . $cookie['name'] . ' = ' . $cookie['value']);
 } else {
 $this->debug('did not find cookie in ' . trim($arr[1]));
 }
 }
 } else if (isset($header_name)) {
 
 $this->incoming_headers[$header_name] .= $lb . ' ' . $header_line;
 }
 }
 
 
 if (isset($this->incoming_headers['transfer-encoding']) && strtolower($this->incoming_headers['transfer-encoding']) == 'chunked') {
 $content_length = 2147483647; 
 $chunked = true;
 $this->debug("want to read chunked content");
 } elseif (isset($this->incoming_headers['content-length'])) {
 $content_length = $this->incoming_headers['content-length'];
 $chunked = false;
 $this->debug("want to read content of length $content_length");
 } else {
 $content_length = 2147483647;
 $chunked = false;
 $this->debug("want to read content to EOF");
 }
 $data = '';
 do {
 if ($chunked) {
 $tmp = fgets($this->fp, 256);
 $tmplen = strlen($tmp);
 $this->debug("read chunk line of $tmplen bytes");
 if ($tmplen == 0) {
 $this->incoming_payload = $data;
 $this->debug('socket read of chunk length timed out after length ' . strlen($data));
 $this->debug("read before timeout:\n" . $data);
 $this->setError('socket read of chunk length timed out');
 return false;
 }
 $content_length = hexdec(trim($tmp));
 $this->debug("chunk length $content_length");
 }
 $strlen = 0;
 while (($strlen < $content_length) && (!feof($this->fp))) {
 $readlen = min(8192, $content_length - $strlen);
 $tmp = fread($this->fp, $readlen);
 $tmplen = strlen($tmp);
 $this->debug("read buffer of $tmplen bytes");
 if (($tmplen == 0) && (!feof($this->fp))) {
 $this->incoming_payload = $data;
 $this->debug('socket read of body timed out after length ' . strlen($data));
 $this->debug("read before timeout:\n" . $data);
 $this->setError('socket read of body timed out');
 return false;
 }
 $strlen += $tmplen;
 $data .= $tmp;
 }
 if ($chunked && ($content_length > 0)) {
 $tmp = fgets($this->fp, 256);
 $tmplen = strlen($tmp);
 $this->debug("read chunk terminator of $tmplen bytes");
 if ($tmplen == 0) {
 $this->incoming_payload = $data;
 $this->debug('socket read of chunk terminator timed out after length ' . strlen($data));
 $this->debug("read before timeout:\n" . $data);
 $this->setError('socket read of chunk terminator timed out');
 return false;
 }
 }
 } while ($chunked && ($content_length > 0) && (!feof($this->fp)));
 if (feof($this->fp)) {
 $this->debug('read to EOF');
 }
 $this->debug('read body of length ' . strlen($data));
 $this->incoming_payload .= $data;
 $this->debug('received a total of '.strlen($this->incoming_payload).' bytes of data from server');
 
 
 if(
 (isset($this->incoming_headers['connection']) && strtolower($this->incoming_headers['connection']) == 'close') || 
 (! $this->persistentConnection) || feof($this->fp)){
 fclose($this->fp);
 $this->fp = false;
 $this->debug('closed socket');
 }
 
 
 if($this->incoming_payload == ''){
 $this->setError('no response from server');
 return false;
 }
 
 





 
 


 
 } else if ($this->scheme == 'https') {
 
 $this->debug('send and receive with cURL');
 $this->incoming_payload = curl_exec($this->ch);
 $data = $this->incoming_payload;

 $cErr = curl_error($this->ch);
 if ($cErr != '') {
 $err = 'cURL ERROR: '.curl_errno($this->ch).': '.$cErr.'<br>';
 
 foreach(curl_getinfo($this->ch) as $k => $v){
 $err .= "$k: $v<br>";
 }
 $this->debug($err);
 $this->setError($err);
 curl_close($this->ch);
 return false;
 } else {
 
 
 
 }
 
 $this->debug('No cURL error, closing cURL');
 curl_close($this->ch);
 
 
 while (ereg('^HTTP/1.1 100',$data)) {
 if ($pos = strpos($data,"\r\n\r\n")) {
 $data = ltrim(substr($data,$pos));
 } elseif($pos = strpos($data,"\n\n") ) {
 $data = ltrim(substr($data,$pos));
 }
 }
 
 
 if ($pos = strpos($data,"\r\n\r\n")) {
 $lb = "\r\n";
 } elseif( $pos = strpos($data,"\n\n")) {
 $lb = "\n";
 } else {
 $this->debug('no proper separation of headers and document');
 $this->setError('no proper separation of headers and document');
 return false;
 }
 $header_data = trim(substr($data,0,$pos));
 $header_array = explode($lb,$header_data);
 $data = ltrim(substr($data,$pos));
 $this->debug('found proper separation of headers and document');
 $this->debug('cleaned data, stringlen: '.strlen($data));
 
 foreach ($header_array as $header_line) {
 $arr = explode(':',$header_line,2);
 if(count($arr) > 1){
 $header_name = strtolower(trim($arr[0]));
 $this->incoming_headers[$header_name] = trim($arr[1]);
 if ($header_name == 'set-cookie') {
 
 $cookie = $this->parseCookie(trim($arr[1]));
 if ($cookie) {
 $this->incoming_cookies[] = $cookie;
 $this->debug('found cookie: ' . $cookie['name'] . ' = ' . $cookie['value']);
 } else {
 $this->debug('did not find cookie in ' . trim($arr[1]));
 }
 }
 } else if (isset($header_name)) {
 
 $this->incoming_headers[$header_name] .= $lb . ' ' . $header_line;
 }
 }
 }

 $arr = explode(' ', $header_array[0], 3);
 $http_version = $arr[0];
 $http_status = intval($arr[1]);
 $http_reason = count($arr) > 2 ? $arr[2] : '';

 
 if (isset($this->incoming_headers['location']) && $http_status == 301) {
 $this->debug("Got 301 $http_reason with Location: " . $this->incoming_headers['location']);
 $this->setURL($this->incoming_headers['location']);
 $this->tryagain = true;
 return false;
 }

 
 if (isset($this->incoming_headers['www-authenticate']) && $http_status == 401) {
 $this->debug("Got 401 $http_reason with WWW-Authenticate: " . $this->incoming_headers['www-authenticate']);
 if (strstr($this->incoming_headers['www-authenticate'], "Digest ")) {
 $this->debug('Server wants digest authentication');
 
 $digestString = str_replace('Digest ', '', $this->incoming_headers['www-authenticate']);
 
 
 $digestElements = explode(',', $digestString);
 foreach ($digestElements as $val) {
 $tempElement = explode('=', trim($val), 2);
 $digestRequest[$tempElement[0]] = str_replace("\"", '', $tempElement[1]);
 }

 
 if (isset($digestRequest['nonce'])) {
 $this->setCredentials($this->username, $this->password, 'digest', $digestRequest);
 $this->tryagain = true;
 return false;
 }
 }
 $this->debug('HTTP authentication failed');
 $this->setError('HTTP authentication failed');
 return false;
 }
 
 if (
 ($http_status >= 300 && $http_status <= 307) ||
 ($http_status >= 400 && $http_status <= 417) ||
 ($http_status >= 501 && $http_status <= 505)
 ) {
 $this->setError("Unsupported HTTP response status $http_status $http_reason (soapclient->response has contents of the response)");
 return false;
 }

 
 if(isset($this->incoming_headers['content-encoding']) && $this->incoming_headers['content-encoding'] != ''){
 if(strtolower($this->incoming_headers['content-encoding']) == 'deflate' || strtolower($this->incoming_headers['content-encoding']) == 'gzip'){
 
 if(function_exists('gzinflate')){
 
 
 
 $this->debug('The gzinflate function exists');
 $datalen = strlen($data);
 if ($this->incoming_headers['content-encoding'] == 'deflate') {
 if ($degzdata = @gzinflate($data)) {
 $data = $degzdata;
 $this->debug('The payload has been inflated to ' . strlen($data) . ' bytes');
 if (strlen($data) < $datalen) {
 
 $this->debug('The inflated payload is smaller than the gzipped one; try again');
 if ($degzdata = @gzinflate($data)) {
 $data = $degzdata;
 $this->debug('The payload has been inflated again to ' . strlen($data) . ' bytes');
 }
 }
 } else {
 $this->debug('Error using gzinflate to inflate the payload');
 $this->setError('Error using gzinflate to inflate the payload');
 }
 } elseif ($this->incoming_headers['content-encoding'] == 'gzip') {
 if ($degzdata = @gzinflate(substr($data, 10))) { 
 $data = $degzdata;
 $this->debug('The payload has been un-gzipped to ' . strlen($data) . ' bytes');
 if (strlen($data) < $datalen) {
 
 $this->debug('The un-gzipped payload is smaller than the gzipped one; try again');
 if ($degzdata = @gzinflate(substr($data, 10))) {
 $data = $degzdata;
 $this->debug('The payload has been un-gzipped again to ' . strlen($data) . ' bytes');
 }
 }
 } else {
 $this->debug('Error using gzinflate to un-gzip the payload');
 $this->setError('Error using gzinflate to un-gzip the payload');
 }
 }
 
 
 
 $this->incoming_payload = $header_data.$lb.$lb.$data;
 } else {
 $this->debug('The server sent compressed data. Your php install must have the Zlib extension compiled in to support this.');
 $this->setError('The server sent compressed data. Your php install must have the Zlib extension compiled in to support this.');
 }
 } else {
 $this->debug('Unsupported Content-Encoding ' . $this->incoming_headers['content-encoding']);
 $this->setError('Unsupported Content-Encoding ' . $this->incoming_headers['content-encoding']);
 }
 } else {
 $this->debug('No Content-Encoding header');
 }
 
 if(strlen($data) == 0){
 $this->debug('no data after headers!');
 $this->setError('no data present after HTTP headers');
 return false;
 }
 
 return $data;
 }

 function setContentType($type, $charset = false) {
 $this->outgoing_headers['Content-Type'] = $type . ($charset ? '; charset=' . $charset : '');
 $this->debug('set Content-Type: ' . $this->outgoing_headers['Content-Type']);
 }

 function usePersistentConnection(){
 if (isset($this->outgoing_headers['Accept-Encoding'])) {
 return false;
 }
 $this->protocol_version = '1.1';
 $this->persistentConnection = true;
 $this->outgoing_headers['Connection'] = 'Keep-Alive';
 $this->debug('set Connection: ' . $this->outgoing_headers['Connection']);
 return true;
 }

 






 


 function parseCookie($cookie_str) {
 $cookie_str = str_replace('; ', ';', $cookie_str) . ';';
 $data = split(';', $cookie_str);
 $value_str = $data[0];

 $cookie_param = 'domain=';
 $start = strpos($cookie_str, $cookie_param);
 if ($start > 0) {
 $domain = substr($cookie_str, $start + strlen($cookie_param));
 $domain = substr($domain, 0, strpos($domain, ';'));
 } else {
 $domain = '';
 }

 $cookie_param = 'expires=';
 $start = strpos($cookie_str, $cookie_param);
 if ($start > 0) {
 $expires = substr($cookie_str, $start + strlen($cookie_param));
 $expires = substr($expires, 0, strpos($expires, ';'));
 } else {
 $expires = '';
 }

 $cookie_param = 'path=';
 $start = strpos($cookie_str, $cookie_param);
 if ( $start > 0 ) {
 $path = substr($cookie_str, $start + strlen($cookie_param));
 $path = substr($path, 0, strpos($path, ';'));
 } else {
 $path = '/';
 }
 
 $cookie_param = ';secure;';
 if (strpos($cookie_str, $cookie_param) !== FALSE) {
 $secure = true;
 } else {
 $secure = false;
 }

 $sep_pos = strpos($value_str, '=');

 if ($sep_pos) {
 $name = substr($value_str, 0, $sep_pos);
 $value = substr($value_str, $sep_pos + 1);
 $cookie= array( 'name' => $name,
 'value' => $value,
 'domain' => $domain,
 'path' => $path,
 'expires' => $expires,
 'secure' => $secure
 ); 
 return $cookie;
 }
 return false;
 }
 
 







 function getCookiesForRequest($cookies, $secure=false) {
 $cookie_str = '';
 if ((! is_null($cookies)) && (is_array($cookies))) {
 foreach ($cookies as $cookie) {
 if (! is_array($cookie)) {
 continue;
 }
 $this->debug("check cookie for validity: ".$cookie['name'].'='.$cookie['value']);
 if ((isset($cookie['expires'])) && (! empty($cookie['expires']))) {
 if (strtotime($cookie['expires']) <= time()) {
 $this->debug('cookie has expired');
 continue;
 }
 }
 if ((isset($cookie['domain'])) && (! empty($cookie['domain']))) {
 $domain = preg_quote($cookie['domain']);
 if (! preg_match("'.*$domain$'i", $this->host)) {
 $this->debug('cookie has different domain');
 continue;
 }
 }
 if ((isset($cookie['path'])) && (! empty($cookie['path']))) {
 $path = preg_quote($cookie['path']);
 if (! preg_match("'^$path.*'i", $this->path)) {
 $this->debug('cookie is for a different path');
 continue;
 }
 }
 if ((! $secure) && (isset($cookie['secure'])) && ($cookie['secure'])) {
 $this->debug('cookie is secure, transport is not');
 continue;
 }
 $cookie_str .= $cookie['name'] . '=' . $cookie['value'] . '; ';
 $this->debug('add cookie to Cookie-String: ' . $cookie['name'] . '=' . $cookie['value']);
 }
 }
 return $cookie_str;
 }
}


?>